package cn.iocoder.yudao.module.member.service.storegoods;

import java.util.*;
import javax.validation.*;

import cn.iocoder.yudao.module.member.controller.admin.storegoods.vo.*;
import cn.iocoder.yudao.module.member.dal.dataobject.storegoods.StoreGoodsDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

/**
 * 商品 Service 接口
 *
 * @author 管理员
 */
public interface StoreGoodsService {

    /**
     * 创建商品
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Integer createStoreGoods(@Valid StoreGoodsSaveReqVO createReqVO);

    /**
     * 更新商品
     *
     * @param updateReqVO 更新信息
     */
    void updateStoreGoods(@Valid StoreGoodsSaveReqVO updateReqVO);

    /**
     * 删除商品
     *
     * @param id 编号
     */
    void deleteStoreGoods(Integer id);

    /**
     * 获得商品
     *
     * @param id 编号
     * @return 商品
     */
    StoreGoodsDO getStoreGoods(Integer id);

    /**
     * 获得商品分页
     *
     * @param pageReqVO 分页查询
     * @return 商品分页
     */
    PageResult<StoreGoodsDO> getStoreGoodsPage(StoreGoodsPageReqVO pageReqVO);


    List<StoreGoodsDO>  getAll(List<Integer> goodsIds);

    List<StoreGoodsDO>  getByCarteenId(Long carteenId);

    PageResult<StoreSaleGoodsPageVO> getSaleGoodsPage(StoreSaleGoodsPageVO pageReqVO);

    Map<Integer,StoreGoodsDO> getPrice(List<Integer> goodsIds);

}